package kptest;

import java.io.InputStream;
import javafx.animation.AnimationTimer;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Text;
import javafx.util.Duration;
import kptest.IFxScene;

public class RTTest implements IFxScene  {
    
    private static Scene createSceneB() {
        
        Group gRT = new Group();
        Scene sceneRT = new Scene(gRT, 300, 300);
        
        Text l = new Text(100, 50, "Another Text Label");

        sceneRT.setFill(Color.GRAY);
        
        //InputStream in = RTTest.class.getClassLoader().getResourceAsStream("resources/images/monster/e3.png");
        //Image img = new Image(in);
        
        Image img = makeImage("Green Apple.gif");
        ImageView imageView = new ImageView(img);
        imageView.setX(50);
        imageView.setY(50);
        imageView.setFitWidth(100);
        imageView.setFitHeight(100);
        
        gRT.getChildren().add(imageView);
        gRT.getChildren().add(l);
        
        Circle circ = new Circle(50, 50, 20, Color.ORANGE);
        gRT.getChildren().add(circ);
                
        return sceneRT;
        
    }
    
    private static Scene createSceneA() {
        Group group = new Group(
            new Rectangle(10, 10, 50, 50) {{
                    setFill(Color.BLUE);
                    setStroke(Color.GREEN);
                    setArcWidth(10);
                    setArcHeight(10);
            }},
            new Rectangle(60, 10, 50, 50) {{
                    setFill(Color.BLUE);
                    setStroke(Color.RED);
            }},
            new Rectangle(110, 10, 50, 50) {{
                setFill(Color.WHITE);
                setStroke(Color.BLUE);
            }});

        Scene scene = new Scene(group, 300, 300 );
        scene.setFill(Color.BLACK);

        for (int x = 0; x < 10; x++) {
            for (int y = 0; y < 10; y++) {
                Rectangle rect = new Rectangle(
                        x * 10 + y * 0.1f + 10,
                        x * 0.1f + y * 10 + 100,
                        5, 5);
                rect.setFill(Color.RED);
                group.getChildren().add(rect);
            }
        }
        
        return scene;
    }
    
    private Scene scene;
    private ImageView iv3;
    
    private void ctor() {
        Group g = new Group();
        scene = new Scene(g, 500, 700);
        
        Scene sceneRTa = createSceneA();
        Object object = sceneRTa.renderToImage(null);
        Image img1 = Image.impl_fromPlatformImage(object);
        
        Scene sceneRTb = createSceneB();
        object = sceneRTb.renderToImage(object);
        Image img2 = Image.impl_fromPlatformImage(object);

        
        ImageView iv1 = new ImageView(img1);
        iv1.setScaleX(0.5); iv1.setScaleY(0.5);
        g.getChildren().add(iv1);

        ImageView iv2 = new ImageView(img2);
        iv2.setTranslateX(200);
        iv2.setTranslateY(0);
        iv2.setScaleX(0.5); iv2.setScaleY(0.5);
        g.getChildren().add(iv2);

        iv3 = new ImageView(img1);
        iv3.setScaleX(0.5); iv3.setScaleY(0.5);
        iv3.setTranslateY(160);
        g.getChildren().add(iv3);
        
        Text l= new Text(50, 50, "Another Text Label");
        g.getChildren().add(l);
                
        createUpdateTimer();
    }
    
    private Object platformImage = null;
    private void updateScene(int ms) {
        platformImage = scene.renderToImage(platformImage);
        iv3.setImage(Image.impl_fromPlatformImage(platformImage));
    }
    
    
    private void createUpdateTimer() {
        AnimationTimer monstersTimer = new AnimationTimer() {
            @Override
            public void handle(long l) {
                updateScene(100);
            }
        };

        monstersTimer.start();
        
    }
    
    private static Image makeImage(String name) {
        java.net.URL url = RTTest.class.getResource(name);
        String st = url.toString();
        return new Image(st);
    }

    
    public RTTest() {    
        ctor();
    }
    
    @Override
    public Scene getScene() {
        return scene;
    }
}
