package kptest;

import com.sun.javafx.perf.PerformanceTracker;
import javafx.animation.*;
import javafx.application.Application;
import javafx.event.*;
import javafx.stage.*;
import javafx.util.Duration;

public class TestApp extends Application {
    
    Stage stage;
    String title;
    PerformanceTracker perfTracker;
    
    void startTitleUpdateTimer() {
        Timeline fpsTimeline = new Timeline();
        fpsTimeline.setCycleCount(Timeline.INDEFINITE);
        KeyFrame fpsKeyFrame = new KeyFrame(Duration.millis(1000), new EventHandler<ActionEvent>() {
            @Override public void handle(ActionEvent e) {
                String sfps = String.format(" FPS: %.2f", perfTracker.getInstantFPS());
                stage.setTitle(title + sfps);
                System.out.println(sfps);
            }
        });
        fpsTimeline.getKeyFrames().add(fpsKeyFrame);
        fpsTimeline.play();
    }
    

    @Override
    public void start(Stage stage) {
        // Stage stage = new Stage( TestOptions.selectStageStyle() );
        stage.initStyle(Test.selectStageStyle());
        IFxScene scene = Test.selectTest();
        stage.setScene(scene.getScene());
        perfTracker = PerformanceTracker.getSceneTracker(stage.getScene());
        title = scene.getClass().getName();
        stage.sizeToScene();
        stage.setTitle(title);
        stage.centerOnScreen();
        stage.show();
        this.stage = stage;
        startTitleUpdateTimer();
    }
        
    @Override
    public void stop() throws Exception {
        PerformanceTracker.releaseSceneTracker(stage.getScene());
    }
    
    public static void main(String[] args) {
        launch(TestApp.class, args);
    }
}

